/* 
	title	:	client.m
	author	:	jolly - alias Patrick Stein
	version	:	1.00
	purpose	:	pdo - throughput test
	
*/

#import <foundation/NSData.h>
#import <foundation/NSDate.h>
#import <foundation/NSString.h>
#import <remote/NXConnection.h>
#import <remote/NXProxy.h>

#import "common.h"

int main(int argc,char **argv)
{
	NSData			*remoteDataObject;
	NSMutableData	*localDataObject;	
	NSDate			*beginDate,*endDate;
	unsigned long	size,singlesize;
	int				i,count;
	

	if( (argc!=3) || ((count=atoi(argv[2]))<=0) )
	{
		printf("Usage: %s <hostname> <count>\n",argv[0]);
		exit(0);
	}
	
	if(nil==(remoteDataObject=(NSData *)[NXConnection connectToName:CONNECTIONNAME onHost:argv[1]]))
	{
		printf("Can't connect to server on host:%s\n",argv[1]);
		exit(1);
	}
	
	size=0L;
	singlesize=(unsigned long)[remoteDataObject length];
	[(NXProxy *)remoteDataObject setProtocolForProxy:@protocol(NSCopying)];

	
	beginDate=[NSDate date];
	printf("Start %s\n",[[beginDate description] cString] );
	
	for(i=0;i<count;i++)
	{
		localDataObject=[remoteDataObject mutableCopy];
		[localDataObject release];
		size+=singlesize;
	}

	endDate=[NSDate date];
	printf("Ended %s\n",[[endDate description] cString] );
	
	printf("Bytes send over the wire: %d in %5.3f seconds\n",size,[endDate timeIntervalSinceDate:beginDate]);
	printf("Throuput: %6.2f kByte/sec\n",((double)(size)/(double)(1000))/[endDate timeIntervalSinceDate:beginDate]);
	
	return 0;
}
	