/* 
	title	:	server.m
	author	:	jolly - alias Patrick Stein
	version	:	1.00
	purpose	:	pdo - throughput test
	
*/

#import <foundation/NSString.h>
#import <foundation/NSData.h>
#import <remote/NXConnection.h>

#import "common.h"

int main(int argc,char **argv)
{
	NSData	*dataObject;
	NSString		*fileName;
	NXConnection	*connection;

	if( argc!=2 )
	{
		printf("Usage: %s <filename>\n",argv[0]);
		exit(1);
	}

	fileName=[NSString stringWithCString:argv[1]];
	if( nil == (dataObject=[[NSData alloc] initWithContentsOfMappedFile:fileName]) )
	{
		NSLog(@"File %@ not found\n",fileName);
		exit(1);
	}
	if( nil == (connection=[NXConnection registerRoot:dataObject withName:CONNECTIONNAME]) )
	{
		NSLog(@"Can't create NXConnection\n");
		exit(1);
	}
	[connection setInTimeout:100];
    [connection setOutTimeout:100];
	[connection run];
	
	return 0;
}
	
